<?php
function member_getMembershiptTypeCostField() { 
    $date=new DateTime("now");
    $thismonth=intval($date->format("n"));
    $thisday=intval($date->format("j"));
    $field="priceband4";
    return $field;
}

function member_getPrices() { 
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select mt.id,mt.displayname,ifnull(cp.priceband1,mt.priceband1) as price from membershiptype mt left join conventionprices cp on cp.membershiptype=mt.id and cp.conventionid=".NEXTCON["id"]." where mt.isactive=1 and listonsite=1";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        $tmparr=array("id"=>$row["id"],"name"=>$row["displayname"],"price"=>$row["price"]);
        array_push($out,$tmparr);
    }
    return $out;
}

function member_getTypeDetailsPrices($id) {
    $out=array("name"=>'',"price"=>'');
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select mt.id,mt.displayname,ifnull(cp.priceband1,mt.priceband1) as price from membershiptype mt left join conventionprices cp on cp.membershiptype=mt.id and cp.conventionid=".NEXTCON["id"]." where mt.id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        $out["id"]=$row["id"];
        $out["name"]=$row["displayname"];
        $out["price"]=$row["price"];
    }
    return $out;
}

function member_getTypeDetails($type) { 
    $out=array();
    $field=member_getMembershiptTypeCostField();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select mt.id,mt.name,ifnull(cp.".$field.",mt.".$field.") as price from membershiptype mt left join conventionprices cp on cp.membershiptype=mt.id and cp.conventionid=".NEXTCON["id"]." where mt.id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $type);
    $stmt->execute();
    $result=$stmt->get_result();
    $row=$result->fetch_assoc();
    $out=array("id"=>$row["id"],"name"=>$row["name"],"price"=>$row["price"]);
    return $out;
}

function member_getDealerTableCost() { 
    $currentrate=member_getMembershiptTypeCostField();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select ".$currentrate." from membershiptype where id=6";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $results=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    if ($results->num_rows==0) {
        $returnvalue="100"; //default value from system
    }
    else {
        $row=$results->fetch_assoc();
        $returnvalue=$row[$currentrate];
    }
    unset($row);
    unset($result);
    $conn->close();
    return $returnvalue;
}

function member_isDealer($membertype){ 
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from membershiptype where id=? and isdealer=1";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $membertype);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==0) {
        return false;
    }
    else {
        return true;
    }
}

function member_hasTables($membertype){ 
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from membershiptype where id=? and hastables=1";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $membertype);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==0) {
        return false;
    }
    else {
        return true;
    }
}

function member_isChild($membertype) { 
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from membershiptype where id=? and ischild=1";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $membertype);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==0) {
        return false;
    }
    else {
        return true;
    }
}

function member_isDisabled($membertype) { 
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from membershiptype where id=? and isdisabled=1";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $membertype);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==0) {
        return false;
    }
    else {
        return true;
    }
}

function member_getMembershipDetails($id) { 
    $out="";
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select name from membershiptype mt join membertoconvention mtc on mt.id=mtc.membertype and conventionid=".NEXTCON["id"]." where mtc.memberid=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==1) {
        $row=$result->fetch_assoc();
        $out=$row["name"];
        unset($row);
    }
    unset($result);
    $conn->close();
    return $out;
}

function member_getPaymentInfo($id) { 
    $out=array("method"=>'',"price"=>'0');
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="SELECT mtc.membercost,ifnull(pm.displayname,'') as name FROM membertoconvention mtc LEFT JOIN membertoconventiontopayment mtctp ON mtctp.membertoconventionid = mtc.id LEFT JOIN payments p on p.id=mtctp.paymentid left join paymentmethods pm on pm.id=p.paymenttypeid WHERE mtc.conventionid = ".NEXTCON["id"]." AND mtc.memberid = ?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==1) {
        $row=$result->fetch_assoc();
        $out["method"]=$row["name"];
        $out["price"]=$row["membercost"];
        unset($row);
    }
    unset($result);
    $conn->close();
    return $out;
}

function member_getMemberCount($id) { 
    $out=0;
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from member where id=? or linkedmemberid=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('ii', $id,$id);
    $stmt->execute();
    $result=$stmt->get_result();
    $out=$result->num_rows;
    unset($result);
    $conn->close();
    return $out;
}

function member_getMemberDetails($id) {
    $out="";
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select firstname,lastname,ifnull(companyname,'') as companyname from member where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==1) {
        $row=$result->fetch_assoc();
        $out=$row["firstname"]." ".$row["lastname"];
        if ($row["companyname"]<>"") {
            $out.="<br>(".$row["companyname"].")";
        }
        unset($row);
    }
    unset($result);
    $conn->close();
    return $out;
}

function member_getLinkedMembersInfo($id) { 
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select firstname,lastname,ifnull(companyname,'') as companyname from member where linkedmemberid=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows>0) {
        while ($row=$result->fetch_assoc()) {
            $tmp=$row["firstname"]." ".$row["lastname"];
            if ($row["companyname"]<>"") {
                $tmp.="<br>(".$row["companyname"].")";
            }
            array_push($out,$tmp);
        }
    }
    unset($result);
    $conn->close();
    return $out;
}

function member_getBadgeType($memtype) {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select defaultbadgetypeid from membershiptype where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $memtype);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows==1) {
        $row=$result->fetch_assoc();
        return $row["defaultbadgetypeid"];
    }
    else {
        return 0;
    }
}

function member_processRecord($arrRecord) {
    $memberid=-1;
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="insert into member (firstname,lastname,badgename,emailaddress,potentialpanelist,datefirstregistered,deleted,companyname,lastupdated,guid) values (?,?,?,?,?,NOW(),0,?,NOW(),UUID());";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('ssssis', $arrRecord["firstname"],$arrRecord["lastname"],$arrRecord["badgename"],$arrRecord["emailaddress"],$arrRecord["panellist"],$arrRecord["companyname"]);
    if ($stmt->execute() !== false) {
        $memberid=$conn->insert_id;
        $sql="insert into membertoconvention (conventionid,memberid,dateregistered,membershipstatus,membercost,membertype,badgetype,numtables,prereg) values (".NEXTCON["id"].",?,now(),3,?,?,?,?,0)";
        $stmt1=$conn->prepare($sql);
        $stmt1->bind_param('idiii', $memberid,$arrRecord["cost"],$arrRecord["type"],member_getBadgeType($arrRecord["type"]),$arrRecord["numberoftables"]);
        $stmt1->execute();
        $sql="insert into membercontact (memberid,guid,conventionid,datesent,isgoh,participant,nosend,responded,suggestions,panelsharing,datereplied,reading,booksigning,curgoh,moderator,hostsgs,arrivaltime,departuretime,nostream) values (?,UUID(),".NEXTCON["id"].",null,0,?,0,0,'','',null,'',0,0,0,0,null,null,0)";
        $stmt2=$conn->prepare($sql);
        $stmt2->bind_param('ii', $memberid,$arrRecord["panellist"]);
        $stmt2->execute();
    }
    return $memberid;
}

function member_linkPayment($mtcid,$payid,$cost) {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="insert into membertoconventiontopayment (membertoconventionid,paymentid,amount) values (?,?,?)";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('iid', $mtcid,$payid,$cost);
    if ($stmt->execute() !== false) {
        return true;
    }
    return false;
}

function member_setActiveStatus($id) { 
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="update membertoconvention set membershipstatus=1 where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    if ($stmt->execute() !== false) {
        return true;
    }
    return false;
}

function member_linkRecords($primary,$secondary) { 
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="update member set linkedmemberid=? where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('ii', $primary,$secondary);
    if ($stmt->execute() !== false) {
        return true;
    }
    return false;
}

function member_getMTCIdForMember($memberid) {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from membertoconvention where conventionid=".NEXTCON["id"]." and memberid=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $memberid);
    $stmt->execute();
    $results=$stmt->get_result();
    debugmode_print(__FILE__, '', $conn, $sql);
    if ($results->num_rows==0) {
        $returnvalue=0;
    }
    else {
        $row=$results->fetch_assoc();
        $returnvalue=$row["id"];
    }
    unset($row);
    unset($result);
    $conn->close();
    return $returnvalue;
}

function member_getMemberDetailsFromArray($arrmembers,$type=0) {
    $returnvalue="";
    $counter=1;
    for ($i=0;$i<count($arrmembers);$i++) {
        if ($type==0) { //members
            $returnvalue.="Member ".$counter."<br>";
            $returnvalue.="Membership Type: ".member_getMembershipTypeName($arrmembers[$i]["type"])."<br>";
            $returnvalue.="Membership Cost: &pound;".(($arrmembers[$i]["cost"]<1)?"Free":$arrmembers[$i]["cost"])."<br>";
            $returnvalue.="First Name: ".$arrmembers[$i]["firstname"]."<br>";
            $returnvalue.="Last Name: ".$arrmembers[$i]["lastname"]."<br>";
            $returnvalue.="Badge Name: ".$arrmembers[$i]["badgename"]."<br>";
            $returnvalue.="Email Address: ".$arrmembers[$i]["emailaddress"]."<br>";
            $returnvalue.="Panellist: ".(($arrmembers[$i]["panellist"]=="1")?"Yes":"No")."<br>";
            $counter++;
        }
        else if ($type==1) { //dealers
            if ($i==0) {
                $returnvalue.="Membership Type: ".member_getMembershipTypeName($arrmembers[$i]["type"])."<br>";
                $returnvalue.="Amount Paid: &pound;".$arrmembers[$i]["membershipcost"]."<br>";
                $returnvalue.="Company Name: ".$arrmembers[$i]["companyname"]."<br>";
                $returnvalue.="Number of Tables: ".$arrmembers[$i]["numtables"]."<br>";
            }
            $returnvalue.="Member ".$counter."<br>";
            $returnvalue.="First Name: ".$arrmembers[$i]["firstname"]."<br>";
            $returnvalue.="Last Name: ".$arrmembers[$i]["lastname"]."<br>";
            $returnvalue.="Badge Name: ".$arrmembers[$i]["badgename"]."<br>";
            $returnvalue.="Email Address: ".$arrmembers[$i]["emailaddress"]."<br>";
            $counter++;
        }
        else if ($type==2) { //artist
            $returnvalue.="Member ".$counter."<br>";
            $returnvalue.="Membership Type: ".member_getMembershipTypeName($arrmembers[$i]["type"])."<br>";
            $returnvalue.="First Name: ".$arrmembers[$i]["firstname"]."<br>";
            $returnvalue.="Last Name: ".$arrmembers[$i]["lastname"]."<br>";
            $returnvalue.="Badge Name: ".$arrmembers[$i]["badgename"]."<br>";
            $returnvalue.="Email Address: ".$arrmembers[$i]["emailaddress"]."<br>";
        }
    }
    return $returnvalue;
}

function member_getMembershipTypeName($membershiptypeid) {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select displayname from membershiptype where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $membershiptypeid);
    $stmt->execute();
    $results=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    if ($results->num_rows==0) {
        $returnvalue=""; //default value from system
    }
    else {
        $row=$results->fetch_assoc();
        $returnvalue=$row["displayname"];
    }
    unset($row);
    unset($result);
    $conn->close();
    return $returnvalue;
}

function member_getMembership($memberid) {
    $member=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select m.guid,m.id,companyname,cast(ifnull(copyok,0) as unsigned int) as copyok,ifnull(numtables,0) as numtables,image,firstname,lastname,badgename,ifnull(linkedmemberid,0) as linkedmemberid,cast(author as unsigned int) as author,cast(booksigning as unsigned int) as booksigning,cast(contactpub as unsigned int) as contactpub,x.membertype,m.emailaddress,m.bio,cast(m.bemoderator as unsigned int) as moderator,cast(m.potentialpanelist as unsigned int) as panelist,cast(m.displayonsite as unsigned int) as listonsite,cast(m.ecomms as unsigned int) as contact,ifnull(x.membertype,m.lastmembertype) as membershiptype,m.lastmembertype,ifnull(x.membershipstatus,2) as membershipstatus from member m left join ( select mtc.* from membertoconvention mtc join convention c on c.id=mtc.conventionid and c.iscurrent=1 ) as x on x.memberid=m.id where m.id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $memberid);
    $stmt->execute();
    $memberresults=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    if ($memberresults->num_rows>0) {
        $rowmembers=$memberresults->fetch_assoc();
        $member["guid"] = (string)$rowmembers["guid"];
        $member["recordid"] = (string)$rowmembers["id"];
        $member["firstname"] = (string)database_toHTMLChar($rowmembers["firstname"]);
        $member["lastname"] = (string)database_toHTMLChar($rowmembers["lastname"]);
        $member["badgename"] = (string)database_toHTMLChar($rowmembers["badgename"]);
        $member["emailaddress"] = (string)$rowmembers["emailaddress"];
        $member["authcode"] = "";
        $member["contact"] = (string)$rowmembers["contact"];
        $member["panelist"] = (string)$rowmembers["panelist"];
        $member["moderator"] = (string)$rowmembers["moderator"];
        $member["listonsite"] = (string)$rowmembers["listonsite"];
        $member["bio"] = (string)database_toHTMLChar($rowmembers["bio"]);
        $member["membershiptype"] = (string)$rowmembers["membershiptype"];
        $member["membershipstatus"] = (string)$rowmembers["membershipstatus"];
        $member["author"]=(string)$rowmembers["author"];
        $member["booksigning"]=(string)$rowmembers["booksigning"];
        $member["contactpub"]=(string)$rowmembers["contactpub"];
        $member["discountcode"] = "";
        $member["lastmembertype"] = (string)($rowmembers["lastmembertype"]==NULL)?"":$rowmembers["lastmembertype"];
        $member["discountcodetype"] = "";
        $member["membershipcost"] = "0";
        $member["linkedmemberid"]='1|'.$rowmembers["linkedmemberid"];
        $member["image"]=$rowmembers["image"];
        $member["permission"]=$rowmembers["copyok"];
        $member["companyname"]=$rowmembers["companyname"];
        $member["numtables"]=$rowmembers["numtables"];
    }
    return $member;
}

function member_generateUpdateUrls($arrmembers) {
    $returnvalue=array();
    $memberids=array();
    for ($i=0;$i<count($arrmembers);$i++) {
        array_push($memberids,$arrmembers[$i]["recordid"]);
    }
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select guid,firstname,lastname from member where id in (".implode(",",$memberids).")";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $results=$stmt->get_result();
    $tmp1="";
    $tmp2="";
    while ($row=$results->fetch_assoc()) {
        $tmp1.=$row["firstname"]." ".$row["lastname"].' - <a href="'.SYSTEMSETTINGS["siteurl"]."?uid=".$row["guid"].'">'.SYSTEMSETTINGS["siteurl"]."?uid=".$row["guid"]."</a><br>";
        $tmp2.=$row["firstname"]." ".$row["lastname"]." - ".SYSTEMSETTINGS["siteurl"]."?uid=".$row["guid"].'\n';
    }
    array_push($returnvalue,$tmp1);
    array_push($returnvalue,$tmp2);
    return $returnvalue;
}
?>
