<?php
function modules_loadModuleIdentifiers() {
	$out=array();
	$conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
	$sql="select id,modulename from modules";
	$stmt=$conn->prepare($sql);
	$stmt->execute();
	$results=$stmt->get_result();
	debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
	while ($row=$results->fetch_assoc()) {
		define("MODULE_ID_".strtoupper($row["modulename"]),$row["id"]);
		$out[$row["id"]]=$row["modulename"];
	}
	return $out;
}

function modules_loadModule($modulename) {
    require(ROOTPATH."/controls/memconfig.inc");
}

function modules_getModuleConfig($modulename) {
	$out=array();
	$conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
	$sql="select chequename,postaladdress,mtc.cutoff,mtc.chequecutoff,mailsettingid,m.id,cast(payments as unsigned int) as payments,cast(ifnull(isactive,0) as unsigned int) as isactive from modules m left join moduletoconvention mtc on mtc.moduleid=m.id and mtc.conventionid=".NEXTCON["id"]." where modulename=?";
	$stmt=$conn->prepare($sql);
	$stmt->bind_param('s', $modulename);
	$stmt->execute();
	$results=$stmt->get_result();
	debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
	$row=$results->fetch_assoc();
	$out["haspayments"]=(bool)$row["payments"];
	$out["id"]=$row["id"];
	$out["mailsettingid"]=($row["mailsettingid"]==null)?"":$row["mailsettingid"];
	$out["cutoff"]=($row["cutoff"]==null)?"":$row["cutoff"];
	$out["chequecutoff"]=($row["chequecutoff"]==null)?"":$row["chequecutoff"];
	$out["chequename"]=($row["chequename"]==null)?"":$row["chequename"];
	$out["postaladdress"]=($row["postaladdress"]==null)?"":$row["postaladdress"];
	$out["isactive"]=(bool)$row["isactive"];
	unset($row);
	unset($result);
	$conn->close();
	return $out;
}

function modules_getModuleSettings() {
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id,modulename from modules";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $resultmodules=$stmt->get_result();
    $sql1="select name,case type when 4 then case value when '' then '0' else value end else value end as value from modulesetting where moduleid=?";
    $stmt1=$conn->prepare($sql1);
    while ($rowmodules=$resultmodules->fetch_assoc()) {
        $out[$rowmodules["modulename"]]=array();
        $stmt1->bind_param('i', $rowmodules["id"]);
        $stmt1->execute();
        $resultsettings=$stmt1->get_result();
        while ($rowsettings=$resultsettings->fetch_assoc()) {
            $out[$rowmodules["modulename"]][$rowsettings["name"]]=$rowsettings["value"];
        }
        unset($rowsettings);
        unset($resultsettings);
    }
    unset($rowmodules);
    unset($resultmodules);
    $conn->close();
    return $out;
}

function modules_getModuleMailSettingsId($moduleid) {
    $returnvalue="";
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select mailsettingid from modules where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $moduleid);
    $stmt->execute();
    $results=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    if ($results->num_rows>0) {
        $row=$results->fetch_assoc();
        $returnvalue=$row["mailsettingid"];
        unset($row);
    }
    unset($results);
    return $returnvalue;
}

?>