<?php
function payment_checkPayPalReceiverEmailIsValid($receiveremail) {
    $returnvalue=false;
    $businessemail=ACTIVEPAYMENTMETHODS["paypal"]["email"];
    if ($businessemail==$receiveremail) {
        $returnvalue=true;
    }
    return $returnvalue;
}


function payment_isCorrectPayPalCurrency($currency) {
    if ($currency==ACTIVEPAYMENTMETHODS["paypal"]["currency"]) {
        return true;
    }
    else  {
        return false;
    }
}

function payment_storePaymentDetails($transactionid,$paymentamount,$payeremail,$filename,$orderid) {
    $conn=new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="insert into payments (orderid,transactionid,paymentamount,paymentstatusid,datecreated,paymenttypeid,emailaddress,conventionid) values (?,?,?,2,now(),1,?,".NEXTCON["id"].")";
    file_put_contents($filename,"command:".$sql."\n",FILE_APPEND);
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('ssds', $orderid,$transactionid,$paymentamount,$payeremail);
    if ($stmt->execute() !== false) {
        file_put_contents($filename,"query successful;\n",FILE_APPEND);
        $recordid=$conn->insert_id;
    }
    else {
        file_put_contents($filename,"query failed;\n",FILE_APPEND);
        file_put_contents($filename,"error:".$conn->error."\n",FILE_APPEND);
        $recordid=-1;
    }
    unset($conn);
}

function payment_isTransactionIdAlreadyUsed($txnid) {
    $returnvalue=false;
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from payments where transactionid=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('s', $txnid);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows>0) {
        $returnvalue=true;
    }
    unset($result);
    unset($conn);
    return $returnvalue;
}

function payment_getTransactionIdFromId($id) {
    $returnvalue="";
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select transactionid from payments where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    if ($result->num_rows>0) {
        $row=$result->fetch_assoc();
        $returnvalue=$row["transactionid"];
        unset($row);
    }
    unset($result);
    unset($conn);
    return $returnvalue;
}

function payment_getConfigValues($recordid) {
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select submiturl,path,protocol,server,currency,socket,foldername from paymentmethods where id=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('i', $recordid);
    $stmt->execute();
    $results=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    $row=$results->fetch_assoc();
    $out["submiturl"]=$row["submiturl"];
    $out["path"]=$row["path"];
    $out["protocol"]=$row["protocol"];
    $out["server"]=$row["server"];
    $out["currency"]=$row["currency"];
    $out["socket"]=$row["socket"];
    $out["folder"]=$row["foldername"];
    unset($row);
    unset($result);
    $conn->close();
    return $out;
}

function payment_getPaymentIdFromReference($ref) { /* inuse */
    $out=0;
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id from payments where orderid=?";
    $stmt=$conn->prepare($sql);
    $stmt->bind_param('s', $ref);
    $stmt->execute();
    $results=$stmt->get_result();
    if ($result->num_rows==1) {
        $row=$result->fetch_assoc();
        $out=$row["id"];
        unset($row);
    }
    unset($result);
    $conn->close();
    return $out;
}

function payment_loadPaymentMethodScriptUrls() {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select scripturl,clientid from paymentmethodtomodule ptm join paymentmethods pm on pm.id=ptm.paymentmethodid where ptm.moduleid=? and onprereg=1 and ptm.isactive=1";
    $stmt=$conn->prepare($sql);
    $id=ACTIVEMODULE["id"];
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        if ($row["scripturl"]!="") {
            echo '<script src="'.str_replace('{clientid}',$row["clientid"],$row["scripturl"]).'"></script>'."\n";
        }
    }
}

function payment_loadPaymentMethodBlurbs() {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select * from paymentmethodtomodule ptm join paymentmethods pm on pm.id=ptm.paymentmethodid where ptm.moduleid=? and onprereg=1 and ptm.isactive=1";
    $stmt=$conn->prepare($sql);
    $id=ACTIVEMODULE["id"];
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        echo "\t\t\t\t\t".'<div id="'.$row["systemname"].'info" class="row" style="display:'.(($row["isdefault"]==1)?"block":"none").'">'."\n";
        echo "\t\t\t\t\t\t".'<div class="col-sm-12 col-xs-12">'."\n";
        echo str_replace('\n','\n\t\t\t\t\t',str_replace('{chequename}',ACTIVEMODULE["chequename"],str_replace('{postaladdress}',ACTIVEMODULE["postaladdress"], $row["blurb"])))."\n";
        echo "\t\t\t\t\t\t</div>\n";
        echo "\t\t\t\t\t</div>\n";
    }
    echo "";
    $stmt->close();
    $conn->close();
}

function payment_loadPaymentMethodButtons() {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select * from paymentmethodtomodule ptm join paymentmethods pm on pm.id=ptm.paymentmethodid where ptm.moduleid=? and onprereg=1 and ptm.isactive=1";
    $stmt=$conn->prepare($sql);
    $id=ACTIVEMODULE["id"];
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        if ($row["type"]==1) {
            echo "\t\t\t\t\t".'<button class="btn btn-warning col-sm-12 col-xs-12" id="committopay" style="display:'.(($row["isdefault"]==1)?"block":"none").'" type="button" onclick="submitForm('.$row["type"].',\''.$row["systemname"].'\',\'\');">'.$row["paybutton"].'</button>'."\n";
        }
        else {
            echo "\t\t\t\t\t".'<div id="'.$row["systemname"].'-button" style="display:'.(($row["isdefault"]==1)?"block":"none").'"></div>'."\n";
        }
    }
    echo "";
    $stmt->close();
    $conn->close();
}

function payment_loadPaymentMethodScriptCode() {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select * from paymentmethodtomodule ptm join paymentmethods pm on pm.id=ptm.paymentmethodid where ptm.moduleid=? and onprereg=1 and ptm.isactive=1";
    $stmt=$conn->prepare($sql);
    $id=ACTIVEMODULE["id"];
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        echo $row["scriptcode"]."\n\n";
    }
    $stmt->close();
    $conn->close();
}

function payment_loadPaymentMethodJSCode(){
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select * from paymentmethodtomodule ptm join paymentmethods pm on pm.id=ptm.paymentmethodid where ptm.moduleid=? and onprereg=1 and ptm.isactive=1";
    $stmt=$conn->prepare($sql);
    $id=ACTIVEMODULE["id"];
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    $hideall="";
    $hidebuttons="";
    $displaybuttons="";
    $showbuttons="";
    $showdefault="";
    while ($row=$result->fetch_assoc()) {
        $hideall.="\t$('#".$row["systemname"]."info').attr('style','display:none');\n";
        $a="if (value==\"paypal\") {
            $('#committopay').attr('style','display:none');
            $('#paypal-button').attr('style','display:inline');
            $('sumup-button').attr('style','display:none');
        }";
        $displaybuttons.=($displaybuttons!="")?"\telse ":"\t";
        if ($row["type"]==1) {
            $hidebuttons.="\t$('#committopay').attr('style','display:none');\n";
            $displaybuttons.="if (value=='".$row["systemname"]."') {\n\t\t$('#committopay').attr('style','display:inline');\n\t}\n";
            $showbuttons.="\t$('#committopay').attr('style','display:".(($row["isdefault"]==1)?"inline":"none")."');\n";
            $showdefault.="\t$('#".$row["systemname"]."info').attr('style','display:".(($row["isdefault"]==1)?"inline":"none")."');\n";
        }
        else {
            $hidebuttons.="\t$('#".$row["systemname"]."-button').attr('style','display:none');\n";
            $displaybuttons.="if (value=='".$row["systemname"]."') {\n\t\t$('#".$row["systemname"]."-button').attr('style','display:inline');\n\t}\n";
            $showbuttons.="\t$('#".$row["systemname"]."-button').attr('style','display:".(($row["isdefault"]==1)?"inline":"none")."');\n";
            $showdefault.="\t$('#".$row["systemname"]."info').attr('style','display:".(($row["isdefault"]==1)?"inline":"none")."');\n";
        }
    }
    echo "function updateInfo(value) {\n";
    echo $hideall;
    echo "\t$('#'+value+'info').attr('style','display:block');\n";
    echo $hidebuttons;
    echo $displaybuttons;
    echo "}\n\n";
    echo "function ShowNothingToPay() {\n";
    echo "\t$('#nothingtopay').attr('style','display:block');\n";
    echo "\t$('#somethingtopay').attr('style','display:none');\n";
    echo "\t$('#complete').attr('style','display:block');\n";
    echo "\t$('#committopay').attr('style','display:none');\n";
    echo $hidebuttons;
    echo "}\n\n";
    echo "function ShowSomethingToPay() {\n";
    echo "\t$('#nothingtopay').attr('style','display:none');\n";
    echo "\t$('#somethingtopay').attr('style','display:block');\n";
    echo "\t$('#complete').attr('style','display:none');\n";
    echo "\t$('#committopay').attr('style','display:none');\n";
    echo $hideall;
    echo $showdefault;
    echo $showbuttons;
    echo "}\n";
    $stmt->close();
    $conn->close();
}

function payment_loadPaymentMethodRadioButtons() {
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select * from paymentmethodtomodule ptm join paymentmethods pm on pm.id=ptm.paymentmethodid where ptm.moduleid=? and onprereg=1 and ptm.isactive=1";
    $stmt=$conn->prepare($sql);
    $id=ACTIVEMODULE["id"];
    $stmt->bind_param('i', $id);
    $stmt->execute();
    $result=$stmt->get_result();
    while ($row=$result->fetch_assoc()) {
        if ($row["type"]==2 || ($row["type"]==1 && (ACTIVEMODULE["cutoffcheque"]==null || date('Y-m-d')<ACTIVEMODULE["cutoffcheque"]))) {
            echo "\t\t\t\t\t\t\t".'<div class="radio">'."\n";
            echo "\t\t\t\t\t\t\t\t".'<label>'."\n";
            echo "\t\t\t\t\t\t\t\t\t".'<input type="radio" name="payoption" '.(($row["isdefault"])?"checked":"").' id="payoption'.$row["id"].'" value="'.$row["systemname"].'" onchange="updateInfo(this.value)">'."\n";
            echo "\t\t\t\t\t\t\t\t\t".'<img src="/images/icons/'.$row["displayimgurl"].'" width="60px"> '.$row["description"]."\n";
            echo "\t\t\t\t\t\t\t\t".'</label>'."\n";
            echo "\t\t\t\t\t\t\t".'</div>'."\n";
        }
    }
    echo "";
    $stmt->close();
    $conn->close();
}

?>