<?php
function system_getNextConDetails() {
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id,name,date,cap from convention where isnext=1";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $result=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    if ($result->num_rows==0) {
        $out["id"]="";
        $out["name"]="";
        $out["date"]="";
        $out["cap"]="";
    }
    else {
        $row=$result->fetch_assoc();
        $out["id"]=$row["id"];
        $out["name"]=$row["name"];
        $out["date"]=$row["date"];
        $out["cap"]=$row["cap"];
    }
    unset($row);
    unset($result);
    $conn->close();
    return $out;
}

function system_getThisConDetails() {
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id,name,date,cap from convention where iscurrent=1";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $result=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    if ($result->num_rows==0) {
        $out["id"]="";
        $out["name"]="";
        $out["date"]="";
        $out["cap"]="";
    }
    else {
        $row=$result->fetch_assoc();
        $out["id"]=$row["id"];
        $out["name"]=$row["name"];
        $out["date"]=$row["date"];
        $out["cap"]=$row["cap"];
    }
    unset($row);
    unset($result);
    $conn->close();
    return $out;
}

function system_getSystemSettings() {
	$out=DEFAULTSYSTEMSETTINGS;
	if (!defined('DATABASESETTINGS')) {
		return $out;
	}
	$conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
	$sql="select name,value from systemsettings where name not like 'admin%'";
	$stmt=$conn->prepare($sql);
	$stmt->execute();
	$result=$stmt->get_result();
	debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
	if ($result->num_rows>0) {
		while ($row=$result->fetch_assoc()) {
		    if ($row["name"]=="siteurl") {
		        $out["usersiteurl"]=$row["value"];
		    }
		    else if ($row["name"]=="preregsiteheader") {
		        $out["siteheader"]=str_replace('{conname}',NEXTCON["name"],$row["value"]);
		    }
		    else if ($row["name"]=="preregsiteurl") {
		        $out["siteurl"]=$row["value"];
		    }
		    else if ($row["name"]=="preregversionnumber") {
		        $out["versionnumber"]=$row["value"];
		    }
		    else {
		        if ($row["name"]!="siteheader" && $row["name"]!="siteurl" && $row["name"]!="versionnumber") {
		        $out[$row["name"]]=$row["value"];
		    }
		    }
		    
		}
		unset($row);
	}
	if ($out["announcement"]!="") {
		$out["hasannouncement"]=1;
	}
	$out["logfilepath"]=$out["logfilepath"]."/presignup/";
	$out["allowedfiletypes"]="gif|png|jpg|jpeg|bmp";
	$max_upload = (int)(ini_get('upload_max_filesize'));
	$max_post = (int)(ini_get('post_max_size'));
	$memory_limit = (int)(ini_get('memory_limit'));
	$upload_mb = min($max_upload, $max_post, $memory_limit);
	$out["maxuploadsizemb"]=$upload_mb;
	$out["maxuploadsizeb"]=$upload_mb*1024*1024;
	unset($result);
	$conn->close();
	return $out;
}

function system_loadActivePaymentMethods($moduleid) {
	$conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
	$sql="select pm.id,foldername,configfile from paymentmethods pm join paymentmethodtomodule pmtm on pmtm.paymentmethodid=pm.id where pm.active=1 and pmtm.moduleid=?";
	$stmt=$conn->prepare($sql);
	$stmt->bind_param('i', $moduleid);
	$stmt->execute();
	$results=$stmt->get_result();
	$out=array();
	$out2=array();
	debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
	while ($row=$results->fetch_assoc()) {
		$configarray=payment_getConfigValues($row["id"]);
		$o2=array(
				'url' => str_replace('{modulename}',ACTIVEMODULE["name"],$configarray["submiturl"]),
				'folder' =>$configarray["folder"],
				'basketdata' => '/modules/'.ACTIVEMODULE["name"].'/payments/'.$configarray["folder"].'/controls/basketdata.inc'
		);
		$o=array(
				'protocol' => $configarray["protocol"],
				'path' => $configarray["path"],
				'server' => $configarray["server"],
				'socket' => $configarray["socket"],
				'currency' => $configarray["currency"],
				'email' => ACTIVEMODULE["ppaccountname"],
				'notifyurl' => str_replace("{siteurl}",SYSTEMSETTINGS["siteurl"],str_replace("{paymentmethod}",$configarray["folder"],ACTIVEMODULE["ppnotifyurl"])),
				'returnurl' => str_replace("{siteurl}",SYSTEMSETTINGS["siteurl"],str_replace("{paymentmethod}",$configarray["folder"],ACTIVEMODULE["ppreturnurl"])),
				'cancelurl' => str_replace("{siteurl}",SYSTEMSETTINGS["siteurl"],str_replace("{paymentmethod}",$configarray["folder"],ACTIVEMODULE["ppcancelurl"]))
		);
		$out[$configarray["folder"]]=$o;
		$out2[$configarray["folder"]]=$o2;
		$configarray=payment_getConfigValues(1);
// 		include ROOTPATH."/payments/".$row["foldername"]."/config/".$row["configfile"];
		unset($configarray);
		unset($o);
		unset($o2);
	}
	define('ACTIVEPAYMENTMETHODS',$out);
	define('PAYMENT',$out2);
	unset($out);
	unset($out2);
}

function system_createGUID() { /* this needs to be checked and see if this is needed on member*/
	$data = openssl_random_pseudo_bytes(16);
	$data[6] = chr(ord($data[6]) & 0x0f | 0x40); // set version to 0100
	$data[8] = chr(ord($data[8]) & 0x3f | 0x80); // set bits 6-7 to 10
	return vsprintf('%s%s-%s-%s-%s-%s%s%s', str_split(bin2hex($data), 4));
}

function system_getMailSettings($mailsettingsid) {
	$out=array();
	$conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
	$sql="select address,name,username,password,server,cast(secure as unsigned int) as secure,port,cast(autotls as unsigned int) as autotls,smtpdebug,cast(smtpauth as unsigned int) as smtpauth from mailsettings where id=?";
	$stmt=$conn->prepare($sql);
	$stmt->bind_param('i', $mailsettingsid);
	$stmt->execute();
	$results=$stmt->get_result();
	debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
	$row=$results->fetch_assoc();
	$out["address"]=$row["address"];
	$out["name"]=$row["name"];
	$out["username"]=$row["username"];
	$out["password"]=$row["password"];
	$out["server"]=$row["server"];
	if ((bool)$row["secure"]) {
	    if ($row["port"]==465) {
    	    $out["secure"]='ssl';
    	}
    	elseif ($row["port"]==587) {
    	    $out["secure"]='tls';
    	}
    	else {
    	    $out["secure"]=false;
    	}
	}
	else {
	    $out["secure"]=false;
	}
	$out["port"]=$row["port"];
	$out["autotls"]=(bool)$row["autotls"];
	$out["smtpdebug"]=$row["smtpdebug"];
	$out["smtpauth"]=(bool)$row["smtpauth"];
	unset($row);
	unset($result);
	$conn->close();
	return $out;
}
?>
