<?php
//EMAIL SETTINGS
define("MAIL_DEBUG",true);

mail_getEmailTemplateList();
define("EMAIL_LOGFILE",SYSTEMSETTINGS["logfilepath"]."mail.log");

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

function mail_sendConfirmationEmail($emailaddress,$membercount,$memberarray,$paymentmethod) {
    $emailtemplate=mail_getEmailTemplate(EMAIL_TEMPLATES["USERCONFIRMATION"]);
    
    $subject=$emailtemplate["subject"];
    $body=$emailtemplate["body"];
    $altbody=$emailtemplate["altbody"];
    
    $memberdetails=member_getMemberDetailsFromArray($memberarray,0);
    $updateurls=member_generateUpdateUrls($memberarray);
    
    $body=str_replace("{username}",$emailaddress,$body);
    $body=str_replace("{membercount}",$membercount,$body);
    $body=str_replace("{memberdetails}",$memberdetails,$body);
    $body=str_replace("{paymentmethod}",$paymentmethod,$body);
    $body=str_replace("{conventionyear}",NEXTCON["name"],$body);
    $body=str_replace("{siteurl}",SYSTEMSETTINGS["siteurl"],$body);
    $body=str_replace("{userupdateurls}",$updateurls[0],$body);
    
    $altbody=str_replace("{username}",$emailaddress,$altbody);
    $altbody=str_replace("{membercount}",$membercount,$altbody);
    $altbody=str_replace("{memberdetails}",$memberdetails,$altbody);
    $altbody=str_replace("{paymentmethod}",$paymentmethod,$altbody);
    $altbody=str_replace("{conventionyear}",NEXTCON["name"],$altbody);
    $altbody=str_replace("{siteurl}",SYSTEMSETTINGS["siteurl"],$altbody);
    $altbody=str_replace("{userupdateurls}",$updateurls[1],$altbody);
    $altbody=str_replace("&pound;", "", $altbody);
    $altbody=str_replace("<br>","\n",$altbody);
    $altbody=str_replace("<br/>","\n",$altbody);
    $altbody=str_replace("<strong>","",$altbody);
    $altbody=str_replace("<p>","",$altbody);
    $altbody=str_replace("</strong>","",$altbody);
    $altbody=str_replace("</p>","\n\n",$altbody);
    
    
    ##DEBUG CODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"membercount:".$membercount,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"memberdetails:".$memberdetails,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"paymentmethod:".$paymentmethod,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($emailaddress, $subject, $body, $altbody);
}

//send email to membership secretary
function mail_sendMembershipConfirmationEmail($membercount,$memberarray,$paymentmethod) {
    $emailtemplate=mail_getEmailTemplate(EMAIL_TEMPLATES["MEMCONFIRMATION"]);
    
    $subject=$emailtemplate["subject"];
    $body=$emailtemplate["body"];
    $altbody=$emailtemplate["altbody"];
    
    $memberdetails=member_getMemberDetailsFromArray($memberarray,0);
    
    $body=str_replace("{membercount}",$membercount,$body);
    $body=str_replace("{memberdetails}",$memberdetails,$body);
    $body=str_replace("{paymentmethod}",$paymentmethod,$body);
    $body=str_replace("{conventionyear}",NEXTCON["name"],$body);
    
    $altbody=str_replace("{membercount}",$membercount,$altbody);
    $altbody=str_replace("{memberdetails}",$memberdetails,$altbody);
    $altbody=str_replace("{paymentmethod}",$paymentmethod,$altbody);
    $altbody=str_replace("&pound;", "", $altbody);
    $altbody=str_replace("{conventionyear}",NEXTCON["name"],$altbody);
    $altbody=str_replace("<br>","\n",$altbody);
    $altbody=str_replace("<br/>","\n",$altbody);
    $altbody=str_replace("<strong>","",$altbody);
    $altbody=str_replace("<p>","",$altbody);
    $altbody=str_replace("</strong>","",$altbody);
    $altbody=str_replace("</p>","\n\n",$altbody);
    
    $emailaddress=MAIL_SETTINGS["address"];
    
    
    ##DEBUGCODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"membercount:".$membercount,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"memberdetails:".$memberdetails,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"paymentmethod:".$paymentmethod,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($emailaddress, $subject, $body, $altbody);
}

function mail_sendMembershipUpdateEmail($membercount,$memberdetails) {
    $emailtemplate=mail_getEmailTemplate(EMAIL_TEMPLATES["MEMUPDATE"]);
    
    $subject=$emailtemplate["subject"];
    $body=$emailtemplate["body"];
    $altbody=$emailtemplate["altbody"];
    
    $body=str_replace("{membercount}",$membercount,$body);
    $body=str_replace("{memberdetails}",$memberdetails,$body);
    $body=str_replace("{conventionyear}",NEXTCON["name"],$body);
    
    $altbody=str_replace("{membercount}",$membercount,$altbody);
    $altbody=str_replace("{memberdetails}",$memberdetails,$altbody);
    $altbody=str_replace("&pound;", "", $altbody);
    $altbody=str_replace("{conventionyear}",NEXTCON["name"],$altbody);
    $altbody=str_replace("<br>","\n",$altbody);
    $altbody=str_replace("<br/>","\n",$altbody);
    $altbody=str_replace("<strong>","",$altbody);
    $altbody=str_replace("<p>","",$altbody);
    $altbody=str_replace("</strong>","",$altbody);
    $altbody=str_replace("</p>","\n\n",$altbody);
    
    $emailaddress=MAIL_SETTINGS["address"];
    
    
    ##DEBUGCODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"membercount:".$membercount,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"memberdetails:".$memberdetails,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($emailaddress, $subject, $body, $altbody);
}

function mail_sendNewMemberParticipantEmail($participantcount,$memberarray) {
    $emailtemplate=mail_getEmailTemplate(EMAIL_TEMPLATES["NEWMEMPART"]);
    
    $subject=$emailtemplate["subject"];
    $body=$emailtemplate["body"];
    $altbody=$emailtemplate["altbody"];
    
    $participantinfo=member_getMemberDetailsFromArray($memberarray,0);
    
    $body=str_replace("{participantcount}",$participantcount,$body);
    $body=str_replace("{participantinfo}",$participantinfo,$body);
    $body=str_replace("{conventionyear}",NEXTCON["name"],$body);
    
    $altbody=str_replace("{participantcount}",$participantcount,$altbody);
    $altbody=str_replace("{participantinfo}",$participantinfo,$altbody);
    $altbody=str_replace("{conventionyear}",NEXTCON["name"],$altbody);
    $altbody=str_replace("<br>","\n\n",$altbody);
    $altbody=str_replace("<br/>","\n\n",$altbody);
    
    $emailaddress=SYSTEMSETTINGS["programmeemailaddress"];
    
    
    ##DEBUGCODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"participantcount:".$participantcount,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"participantinfo:".$participantinfo,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($emailaddress, $subject, $body, $altbody);
}

function mail_sendNewMemberArtistEmail($artistcount,$memberarray) {
    $emailtemplate=mail_getEmailTemplate(EMAIL_TEMPLATES["NEWMEMART"]);
    
    $subject=$emailtemplate["subject"];
    $body=$emailtemplate["body"];
    $altbody=$emailtemplate["altbody"];
    
    $participantinfo=member_getMemberDetailsFromArray($memberarray,2);
    
    $body=$artistinfo("{artistcount}",$artistcount,$body);
    $body=str_replace("{artistinfo}",$artistinfo,$body);
    $body=str_replace("{conventionyear}",NEXTCON["name"],$body);
    
    $altbody=str_replace("{artistcount}",$artistcount,$altbody);
    $altbody=str_replace("{artistinfo}",1,$altbody);
    $altbody=str_replace("{conventionyear}",NEXTCON["name"],$altbody);
    $altbody=str_replace("<br>","\n\n",$altbody);
    $altbody=str_replace("<br/>","\n\n",$altbody);
    
    $emailaddress=SYSTEMSETTINGS["artistemailaddress"];
    
    
    ##DEBUGCODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"participantcount:".$participantcount,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"participantinfo:".$participantinfo,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($emailaddress, $subject, $body, $altbody);
}

function mail_sendNewMemberDealerEmail($dealercount,$memberarray) {
    $emailtemplate=mail_getEmailTemplate(EMAIL_TEMPLATES["NEWMEMDEAL"]);
    
    $subject=$emailtemplate["subject"];
    $body=$emailtemplate["body"];
    $altbody=$emailtemplate["altbody"];
    
    $dealerinfo=member_getMemberDetailsFromArray($memberarray);
    
    $body=str_replace("{dealercount}",$dealercount,$body);
    $body=str_replace("{dealerinfo}",$dealerinfo,$body);
    $body=str_replace("{conventionyear}",NEXTCON["name"],$body);
    
    $altbody=str_replace("{dealercount}",$dealercount,$altbody);
    $altbody=str_replace("{dealerinfo}",$dealerinfo,$altbody);
    $altbody=str_replace("{conventionyear}",NEXTCON["name"],$altbody);
    $altbody=str_replace("<br>","\n\n",$altbody);
    $altbody=str_replace("<br/>","\n\n",$altbody);
    
    $emailaddress=SYSTEMSETTINGS["dealeremailaddress"];
    
    
    ##DEBUGCODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"dealercount:".$dealercount,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"dealerinfo:".$dealerinfo,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($emailaddress, $subject, $body, $altbody);
}


####
#### Generic Email Functions
####
function mail_sendProgrammeFeedbackCopy($contactid=0,$response,$title) {
    
    $programmeemailaddress=SYSTEMSETTINGS["programmeemailaddress"];
    
    $subject=$title;
    
    $body=$response;
    
    $altbody=$response;
    $altbody=str_replace("<p>","",$altbody);
    $altbody=str_replace("</p>","\n\n",$altbody);
    $altbody=str_replace("<br>","\n",$altbody);
    
    ##DEBUG CODE
    if (MAIL_DEBUG) {
        file_put_contents(EMAIL_LOGFILE,"\n-----".__FUNCTION__."------\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"contactid:".$contactid,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"response:".$response,FILE_APPEND);
        file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
    }
    
    return mail_sendEmail($programmeemailaddress, $subject, $body, $altbody);
}

//this actually sends the email
function mail_sendEmail($emailaddress,$subject,$body,$altbody) {
	
	$mail=new PHPMailer();
	try {
		//Server settings
		$mail->SMTPDebug=0;
		$mail->isSMTP();
		$mail->Host=MAIL_SETTINGS["server"];
		$mail->SMTPAuth=MAIL_SETTINGS["smtpauth"];
		$mail->Username=MAIL_SETTINGS["username"];
		$mail->Password=MAIL_SETTINGS["password"];
		$mail->SMTPSecure=MAIL_SETTINGS["secure"];
		$mail->Port=MAIL_SETTINGS["port"];
		
		//Recipients
		$mail->setFrom(MAIL_SETTINGS["address"], MAIL_SETTINGS["name"]);
		$mail->addAddress($emailaddress,$emailaddress);
		
		//Content
		$mail->isHTML(true);
		$mail->Subject=$subject;
		$mail->Body=$body;
		$mail->AltBody=$altbody;
		
		if (SYSTEMSETTINGS["sendemail"]) {
		    $mail->send();
		}
		//log the outgoing email details for debugging
		if (MAIL_DEBUG) {
			file_put_contents(EMAIL_LOGFILE,"\n-------".__FUNCTION__."-----------\n",FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"emailaddress:".$emailaddress,FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"subject:".$subject,FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"body:".$body,FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"altbody:".$altbody,FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"MAIL OBJECT:",FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,print_r($mail,true),FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"ERROR DETAILS:".$mail->ErrorInfo,FILE_APPEND);
			file_put_contents(EMAIL_LOGFILE,"\n",FILE_APPEND);
		}
		return true;
	} catch (Exception $e) {
		return false;;
	}
}

function mail_getEmailTemplate($templateid) {
	$out=array(
			"subject" => "",
			"body" => "",
			"altbody" => ""
	);
	$conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
	$sql="select subject,body,altbody from emailtemplates where id=?";
	$stmt=$conn->prepare($sql);
	$stmt->bind_param('s', $templateid);
	$stmt->execute();
	$result=$stmt->get_result();
	debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
	$rowcount=$result->num_rows;
	if ($rowcount == 1) {
		$row=$result->fetch_assoc();
		$out["subject"]=$row["subject"];
		$out["body"]=$row["body"];
		$out["altbody"]=$row["altbody"];
	}
	unset($row);
	unset($result);
	$conn->close();
	return $out;
}

function mail_getEmailTemplateList() {
    $out=array();
    $conn = new mysqli(DATABASESETTINGS["host"], DATABASESETTINGS["username"], DATABASESETTINGS["password"], DATABASESETTINGS["schema"]);
    $sql="select id,shortname from emailtemplates";
    $stmt=$conn->prepare($sql);
    $stmt->execute();
    $result=$stmt->get_result();
    debugmode_print(__FILE__, __FUNCTION__, $conn, $sql);
    while ($row=$result->fetch_assoc()) {
        $out[$row["shortname"]]=$row["id"];
    }
    define('EMAIL_TEMPLATES',$out);
}
?>
