/**
 * 
 */

var Password = {
 
  _pattern : /[a-zA-Z0-9_\-\+\.]/,
  
  
  _getRandomByte : function()
  {
    // http://caniuse.com/#feat=getrandomvalues
    if(window.crypto && window.crypto.getRandomValues) 
    {
      var result = new Uint8Array(1);
      window.crypto.getRandomValues(result);
      return result[0];
    }
    else if(window.msCrypto && window.msCrypto.getRandomValues) 
    {
      var result = new Uint8Array(1);
      window.msCrypto.getRandomValues(result);
      return result[0];
    }
    else
    {
      return Math.floor(Math.random() * 256);
    }
  },
  
  generate : function(length)
  {
    return Array.apply(null, {'length': length})
      .map(function()
      {
        var result;
        while(true) 
        {
          result = String.fromCharCode(this._getRandomByte());
          if(this._pattern.test(result))
          {
            return result;
          }
        }        
      }, this)
      .join('');  
  }    
    
};

function generatePassword(length,pwfieldid,conffieldid,viewablefieldid) {
	var pw=Password.generate(length);
	$('#'+pwfieldid).val(pw);
	$('#'+conffieldid).val(pw);
	$('#'+viewablefieldid).html(pw);
}

function validateField(value,type,event) {
	if (event.keyCode==8 || event.keyCode==9 || event.keyCode==46  || event.keyCode==37  || event.keyCode==38  || event.keyCode==39 || event.keyCode==40  ) {
		return true;
	}
	var numbers = /[\-0-9]/g;
	var numbersDot = /[0-9\.]/g;
	var alphabetNumbers = /\-[A-Za-z0-9]/g;
	var alphabetNumbersUnderscore = /[A-Za-z0-9_]/g;
	var alphabetNumbersUnderscoreAtDot = /[A-Za-z0-9_@\.]/g;
	var alphabetNumbersSpaceUnderscore = /[A-Za-z0-9_ ]/g;
	var alphabetNumbersSpace = /[A-Za-z0-9 ]/g;
	var key = String.fromCharCode(event.which);
	switch (type) {
	case 'anuad':
		if (alphabetNumbersUnderscoreAtDot.test(key)) {
			return true;
		}
		break;
	case 'ansu':
		if (alphabetNumbersUnderscoreSpace.test(key)) {
			return true;
		}
		break;
	case 'ans':
		if (alphabetNumbersSpace.test(key)) {
			return true;
		}
		break;
	case 'anu':
		if (alphabetNumbersUnderscore.test(key)) {
			return true;
		}
		break;
	case 'n':
			if (numbers.test(key)) {
				return true;
			}
		break;
	case 'nd':
		if (numbersDot.test(key)) {
			return true;
		}
	break;
	default:
		if (alphabetNumbers.test(key)) {
			return true;
		}
		break;
	}

	event.preventDefault();
	return false;
}

function checkEmailField(field,parentdiv,errorli,errordiv,prefixcode,required) {
	if (field.value!=undefined) {
		var fieldvalue=field.value;
	} else {
		var fieldvalue=field[0].value;
	}
	var haserror=false;
	
	if (fieldvalue=="") {
		if (!required) {
			haserror=false;
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
		}
		else {
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-error');
			haserror=true;
		}
	}
	else {
		var emailReg = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
		if (emailReg.test(fieldvalue)) {
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-success');
			haserror=false;
		}
		else {
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-error');
			haserror=true;
		}
	}
	if (errorli!=undefined) {
		tmp=errorli.split("|");
		for (i=0;i<tmp.length;i++) {
			$('#'+tmp[i]).attr('style',(haserror)?'display:block':'display:none');
		}
	}
	if (errordiv!=undefined) {
		checkAlertDiv(errordiv,prefixcode);
	}
}

function checkWhitespace(field,parentdiv,errorli,errordiv,prefixcode) {
	if (field.value!=undefined) {
		var fieldvalue=field.value;
	} else {
		var fieldvalue=field[0].value;
	}
	var haserror=false;
	if (fieldvalue.length==0) {
		$("#"+parentdiv).removeClass('has-error');
		$("#"+parentdiv).removeClass('has-success');
		haserror=false;
	}
	else {
		fieldvalue=fieldvalue.replace(/\s/g, '');
		if (fieldvalue.length==0) {
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-error');
			haserror=true;
		}
		else {
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-success');
			haserror=false;
		}
	}
	if (errorli!=undefined) {
		tmp=errorli.split("|");
		for (i=0;i<tmp.length;i++) {
			$('#'+tmp[i]).attr('style',(haserror)?'display:block':'display:none');
		}
	}
	if (errordiv!=undefined) {
		checkAlertDiv(errordiv,prefixcode);
	}
}

function validateHasStuff(field,parentdiv,errorli,errordiv,requiredli,prefixcode) {
	if (field.value!=undefined) {
		var fieldvalue=field.value;
	} else {
		var fieldvalue=field[0].value;
	}
	var haserror=false;
	if (fieldvalue.length==0) {
		$("#"+parentdiv).removeClass('has-error');
		$("#"+parentdiv).removeClass('has-success');
		haserror=true;
		if (requiredli!=undefined) {
			$("#"+parentdiv).addClass('has-error');
			if (errorli!=undefined) {
				tmp=errorli.split("|");
				for (i=0;i<tmp.length;i++) {
					$('#'+tmp[i]).attr('style','display:none');
				}
			}
			$('#'+requiredli).attr('style',((haserror)?'display:block':'display:none'));
		}
	}
	else {
		fieldvalue=fieldvalue.replace(/\s/g, '');
		if (fieldvalue.length==0) {
			haserror=true;
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-error');
		}
		else {
			haserror=false;
			$("#"+parentdiv).removeClass('has-error');
			$("#"+parentdiv).removeClass('has-success');
			$("#"+parentdiv).addClass('has-success');
		}
		if (requiredli!=undefined) {
			$('#'+requiredli).attr('style','display:none');
		}
		if (errorli!=undefined) {
			tmp=errorli.split("|");
			for (i=0;i<tmp.length;i++) {
				$('#'+tmp[i]).attr('style',(haserror)?'display:block':'display:none');
			}
		}
	}
	if (errordiv!=undefined) {
		checkAlertDiv(errordiv,prefixcode);
	}
}

function validateHasStuff2(field,field2,parentdiv,parentdiv2,errorli,errordiv,requiredli,prefixcode) {
	var haserror=false;
	var haserror2=false;
	$("#"+parentdiv2).removeClass('has-error');
	$("#"+parentdiv2).removeClass('has-success');
	$("#"+parentdiv).removeClass('has-error');
	$("#"+parentdiv).removeClass('has-success');
	$('#'+requiredli).attr('style','display:none');
	//check to see if either field1 or field2 are populated if one is then the other must be
	if ($('#'+field).val().length>0 || $('#'+field).val().replace(/\s/g, '').length>0) {
		if ($('#'+field2).val().length==0 || $('#'+field2).val().replace(/\s/g, '').length==0) {
			haserror2=true; //lastname empty
			$("#"+parentdiv2).addClass('has-error');
			$('#'+requiredli).attr('style','display:block');
		}
		else {
			$("#"+parentdiv).addClass('has-success');
			$("#"+parentdiv2).addClass('has-success');
		}
	}
	else if ($('#'+field2).val().length>0 || $('#'+field2).val().replace(/\s/g, '').length>0) {
		if ($('#'+field).val().length==0 || $('#'+field).val().replace(/\s/g, '').length==0) {
			haserror=true; //firstname empty
			$("#"+parentdiv).addClass('has-error');
			$('#'+requiredli).attr('style','display:block');
		}
		else {
			$("#"+parentdiv).addClass('has-success');
			$("#"+parentdiv2).addClass('has-success');
		}
	}
	if (errordiv!=undefined) {
		checkAlertDiv(errordiv);
	}
}

function validateHasStuffLength(field,parentdiv,rqdlen,prefixcode) {
	if (field.value!=undefined) {
		var fieldvalue=field.value;
	} else {
		var fieldvalue=field[0].value;
	}
	fieldvalue=fieldvalue.replace(/\s/g, '');
	if (fieldvalue.length!=rqdlen) {
		$("#"+parentdiv).removeClass('has-error');
		$("#"+parentdiv).removeClass('has-success');
		$("#"+parentdiv).addClass('has-error');
	}
	else {
		$("#"+parentdiv).removeClass('has-error');
		$("#"+parentdiv).removeClass('has-success');
		$("#"+parentdiv).addClass('has-success');
	}
}

function hideAlertDivContents(divid) {
	$("#"+divid).find('li').each(function(i) {
		$(this).attr("style","display:none");
	});
}

function checkAlertDiv(divid) { //returns true if not ok and false if not
	var displayerrordiv=false;
	var obj=$("#"+divid);
	obj.find('li').each(function(i) {
		if ($(this).attr("style")=="display:block") {
			displayerrordiv=true;
		}
	});
	if (displayerrordiv) {
		$('#'+divid).attr('style','display:block');
	}
	else {
		$('#'+divid).attr('style','display:none');
	}
	return displayerrordiv;
}

function scrollSmoothToBottom(id) {
   var div = document.getElementById(id);
   $("html, body").animate({
      scrollTop: $(document).height()
   }, 500);
}

function scrollSmoothToPayment(id) {
   var div = document.getElementById(id);
   $('#' + id).animate({
      scrollTop: div.scrollHeight - div.clientHeight
   }, 500);
}
function clearNumTablesError(parentdiv,prefixcode,errorli,errordiv) {
	$("#"+parentdiv).removeClass('has-error');
	$("#"+parentdiv).removeClass('has-success');
	$('#'+errorli).attr('style','display:none');
	if (errordiv!=undefined) {
		checkAlertDiv(errordiv,prefixcode);
	}
}

function updateCost() {
	var cost=$('#costpertable').val();
	var numtables=$('#numberoftables').val();
	var totalcost=(cost*numtables);
	$('#cost').val(totalcost);
	$('#memberprice').html('&pound;'+totalcost);
}

function displayPaymentModal(cost) {
	if (cost>0) {
		$('#nothingtopay').attr('style','display:none');
		$('#somethingtopay').attr('style','display:block');
		$('#payoption1').prop('checked',true);
		$('#payoption1').attr('checked',true);
		$('#inpersoninfo').attr('style','display:none');
		$('#paypalinfo').attr('style','display:block');
		$('#committopay').attr('style','display:none');
		$('#complete').attr('style','display:none');
		$('#paypal-button').attr('style','display:inline');
	}
	else {
		$('#nothingtopay').attr('style','display:block');
		$('#somethingtopay').attr('style','display:none');
		$('#inpersoninfo').attr('style','display:none');
		$('#paypalinfo').attr('style','display:none');
		$('#committopay').attr('style','display:none');
		$('#complete').attr('style','display:inline');
		$('#paypal-button').attr('style','display:none');
	}
	$('#purchasemodal').modal('show');
}

function resetForm() {
	$('#firstname').val('');
	$('#lastname').val('');
	$('#badgename').val('');
	$('#emailaddress').val('');
}

function submitForm(paytype,refno) {
	$('#paytype').val(paytype);
	$('#payref').val(refno);
	$('#registerform')[0].submit();
}

function payment_displayCancelModal() {
	$('#purchasemodal').modal('hide');
	$('#paypalpaymentmodal').modal('show');
}

function validateForm() {
	var type=$('#memtype').val();
	$('#firstname').blur();
	$('#lastname').blur();
	$('#emailaddress').blur();
	if (type==6) { //dealer
		$('#companyname').blur();
	}	
	if (checkAlertDiv('alertbasketerror',0)) {
		alert('There are things that need attention, please correct them and try again');
		$('#alertbasketerror').animate({ scrollTop: 0 }, 'slow');
		return false;
	}
	else {
		if (!checkExtraFields(type)) {
			alert('There are things that need attention, please correct them and try again');
			$('#alertbasketerror').animate({ scrollTop: 0 }, 'slow');
			return false;
		}
		else {
			var cost=$('#cost').val();
			displayPaymentModal(cost);
		}
	}
}

function checkExtraFields(type) { //returns true if ok false if not
	if (type==9) {
		//check carer
		if ($('#firstname2').val()!="" || $('#lastname2').val()!="") { //carer
			if ($('#firstname2').val()=="" || $('#lastname2').val()=="") {
				return false;
			}
		}
		return true;
	}
	else if (type==6) {
		//check dealer2 and dealer3
		if ($('#firstname2').val()!="" || $('#lastname2').val()!="") { //dealer2
			if ($('#firstname2').val()=="" || $('#lastname2').val()=="") {
				return false;
			}
		}
		if ($('#firstname3').val()!="" || $('#lastname3').val()!="") { //dealer 3
			if ($('#firstname3').val()=="" || $('#lastname3').val()=="") {
				return false;
			}
		}
		return true;
	}
	else {
		return true;
	}
}

function checkEmailMatches(email1,email2,parentdiv1,parentdiv2,errorli,errordiv) {
	var haserror=false;
	if ($('#'+email1).val()!="" && $('#'+email2).val()!="") {
		if ($('#'+email1).val()!=$('#'+email2).val()) {
			$("#"+parentdiv1).removeClass('has-error');
			$("#"+parentdiv1).removeClass('has-success');
			$("#"+parentdiv1).addClass('has-error');
			$("#"+parentdiv2).removeClass('has-error');
			$("#"+parentdiv2).removeClass('has-success');
			$("#"+parentdiv2).addClass('has-error');
			haserror=true;
		}
		else {
			$("#"+parentdiv1).removeClass('has-error');
			$("#"+parentdiv1).removeClass('has-success');
			$("#"+parentdiv1).addClass('has-success');
			$("#"+parentdiv2).removeClass('has-error');
			$("#"+parentdiv2).removeClass('has-success');
			$("#"+parentdiv2).addClass('has-success');
		}
	}
	else {
		
	}
	if (errorli!=undefined) {
		tmp=errorli.split("|");
		for (i=0;i<tmp.length;i++) {
			$('#'+tmp[i]).attr('style',(haserror)?'display:block':'display:none');
		}
	}
	if (errordiv!=undefined) {
		checkAlertDiv(errordiv);
	}
}

function displayConfirmationModal() {
	$('#purchasemodal').modal('hide');
	$('#confirmationmodal').modal({backdrop: 'static', keyboard: false});
}

function updateButtons(btn1,btn2,state) {
	$('#'+btn1).removeClass('btn-success');
	$('#'+btn2).removeClass('btn-danger');
	
	if (state) {
		$('#'+btn1).addClass('btn-success');
		//$('#'=btn2).addClass('');
	}
	if (!state) {
		$('#'+btn2).addClass('btn-danger');
		//$('#'=btn2).addClass('');
	}
}